
#ifndef __POL2BB_H__
#define __POL2BB_H__
/***********
Currently very messy, with lot of code to be removed, but it's used
for the meshes and your draw list.
If it's your avatar isn't in the area of the mesh's bounding box, you don't draw it.
If it is, you can add extra verifications (such as viewing frustrum culling), and if it passes
the tests, you draw the mesh.
TODO : Add mesh auto-subdivision
TODO : Proper octree implementation
***********/
#include <math.h>
#define PI 3.14159265

vector3 list_vertices[3000] = {0};
_BB_Hitbox list_per_poly_bb[3000];
int list_vertices_total_points = 0;
int list_polygons_total_poly = 0;





/*************
Makes a list of all the vertices in your file. Since the Jo Engine Map editor outputs ID that increase between different meshes, it
allows us to keep a global list.
EDIT : Not useful anymore with .OBJ files. Could be used to store all vertices and generate bounding boxes independant of the actual objects.
**************/
/*void fill_list_vertices(void)
{
    for (int meshID = 0; meshID < total_mesh; meshID++)
    {

        for (int i = 0; i < mesh_array[meshID].data.nbPoint; i++)
        {
            list_vertices[list_vertices_total_points].x = mesh_array[meshID].data.pntbl[i][0];
            list_vertices[list_vertices_total_points].y = mesh_array[meshID].data.pntbl[i][1];
            list_vertices[list_vertices_total_points].z = mesh_array[meshID].data.pntbl[i][2];
            list_vertices_total_points ++;
        }
    }
}*/

/*
void deletevalues(int i)
{
                      for (int j=i; j< list_polygons_total_poly-1; j++)
               {
                    poly_bb[j].MaxValue.x = poly_bb[j+1].MaxValue.x; poly_bb[j].MaxValue.y = poly_bb[j+1].MaxValue.y; poly_bb[j].MaxValue.z = poly_bb[j+1].MaxValue.z;
                    poly_bb[j].MinValue.x = poly_bb[j+1].MinValue.x; poly_bb[j].MinValue.y = poly_bb[j+1].MinValue.y; poly_bb[j].MinValue.z = poly_bb[j+1].MinValue.z;
               }
}*/

int MaskArray[200][200]={0};
int Total_Mask = 0;
int CreateMask(_BB_Hitbox buffer)
{
        int tempMask[200]={0};
        int tempMaskLength = 0;
        bool duplicate = true;
        if (buffer.Rotation.x == 0 && buffer.Rotation.z == 0) return -1;
        else
        {
            if (buffer.Rotation.x != 0)
            {
                if (buffer.Rotation.x > 0)
                {
                    for (int i=0; i<(buffer.MaxValue.z-buffer.MinValue.z); i++)
                    {
                        tempMask[i]= cos(buffer.Rotation.x * PI / 180.0) * i;
                        if (tempMask[i]>= buffer.MaxValue.y - buffer.MinValue.y) tempMask[i]=buffer.MaxValue.y - buffer.MinValue.y - 1;
                    }
                }
                else
                {
                    for (int i=0; i<(buffer.MaxValue.z-buffer.MinValue.z); i++)
                    {
                        tempMask[i]= cos(buffer.Rotation.x * PI / 180.0) * (buffer.MaxValue.z - buffer.MinValue.z - i);
                        if (tempMask[i]>= buffer.MaxValue.y - buffer.MinValue.y) tempMask[i]=buffer.MaxValue.y - buffer.MinValue.y - 1;
                    }
                }
                tempMaskLength = buffer.MaxValue.z - buffer.MinValue.z;
            }
            else if (buffer.Rotation.z != 0)
            {
                if (buffer.Rotation.z > 0)
                {
                    for (int i=0; i<(buffer.MaxValue.x - buffer.MinValue.x); i++)
                    {
                        tempMask[i]= cos(buffer.Rotation.z * PI / 180.0) * i;
                        if (tempMask[i]>= buffer.MaxValue.y - buffer.MinValue.y) tempMask[i]=buffer.MaxValue.y - buffer.MinValue.y - 1;
                    }
                }
                else
                {
                    for (int i=0; i<(buffer.MaxValue.x - buffer.MinValue.x); i++)
                    {
                        tempMask[i]= cos(buffer.Rotation.z * PI / 180.0) * (buffer.MaxValue.x-buffer.MinValue.x - i);
                        if (tempMask[i]>= buffer.MaxValue.y - buffer.MinValue.y) tempMask[i]=buffer.MaxValue.y - buffer.MinValue.y - 1;
                    }
                }
                tempMaskLength = buffer.MaxValue.x - buffer.MinValue.x;
            }
        }

        for (int i=0; i<Total_Mask; i++)
        {
            for (int ii=0; ii<tempMaskLength; ii++)
            {
                if (tempMask[ii] != MaskArray[i][ii])
                duplicate = false;
            }
            if (duplicate==true) return i;
        }

    for (int i=0; i< 200; i++)
    {
        MaskArray[Total_Mask][i] = tempMask[i];
    }

    Total_Mask++;
    return Total_Mask-1;
}

typedef struct
{
  _BB_Hitbox poly_bb[3000];
  int       total_bb;
} _poly_bb;

_poly_bb bb_array[3000];// = {0};

void initialize_bb_array(void)
{
    for (int i=0; i<3000; i++)
    {
        bb_array[i].total_bb=0;
        for (int ii=0; ii<3000; ii++)
        {
            bb_array[i].poly_bb[ii].MaskID=-1;
            bb_array[i].poly_bb[ii].MaxValue.x = 0; bb_array[i].poly_bb[ii].MaxValue.y = 0; bb_array[i].poly_bb[ii].MaxValue.z = 0;
            bb_array[i].poly_bb[ii].MinValue.x = 0; bb_array[i].poly_bb[ii].MinValue.y = 0; bb_array[i].poly_bb[ii].MinValue.z = 0;
            bb_array[i].poly_bb[ii].Rotation.x = 0; bb_array[i].poly_bb[ii].Rotation.y = 0; bb_array[i].poly_bb[ii].Rotation.z = 0;
        }
    }
}

/***************************
To avoid having too many bounding boxes, we attempt to regroup them here. If it returns > 0, that means there is a duplicate and we won't write it in the file, but
we will update it to merge the boxes. Right now, it's not efficient enough as it might reduce a file with 2 300 polygons to 900 boxes, but by manually writing bounding boxes you
might be able to reduce that number to 100.
Div by 2 to round up and prevent having 1 unit difference preventing the merge
***************************/
int refine_poly_2_bb_list(_BB_Hitbox *passedBuffer, int currentMesh)
{

    //if ((passedBuffer->Rotation.x !=0 && passedBuffer->Rotation.x != 90 && passedBuffer->Rotation.x != -90) || (passedBuffer->Rotation.z != 0 && passedBuffer->Rotation.z != 90 && passedBuffer->Rotation.z != -90)) return 0;
    if (passedBuffer->MaskID >= 0) {return 0;}
    int merged = 0; /********** RETURNS AMOUNT OF MERGED BOXES **/
    for (int i=0; i < bb_array[currentMesh].total_bb; i++)
    {
        if (bb_array[currentMesh].poly_bb[i].MaskID >= 0)
             {/* We just don't overwrite it... */}
        else if ((bb_array[currentMesh].poly_bb[i].MaxValue.x/2 == passedBuffer->MinValue.x/2) && (bb_array[currentMesh].poly_bb[i].MaxValue.y/2 == passedBuffer->MaxValue.y/2 && bb_array[currentMesh].poly_bb[i].MinValue.y/2 == passedBuffer->MinValue.y/2) && (bb_array[currentMesh].poly_bb[i].MaxValue.z/2 == passedBuffer->MaxValue.z/2 && bb_array[currentMesh].poly_bb[i].MinValue.z/2 == passedBuffer->MinValue.z/2))
        {
            bb_array[currentMesh].poly_bb[i].MaxValue.x = passedBuffer->MaxValue.x;
            merged ++;
        }
        else if ((bb_array[currentMesh].poly_bb[i].MinValue.x/2 == passedBuffer->MaxValue.x/2) && (bb_array[currentMesh].poly_bb[i].MaxValue.y/2 == passedBuffer->MaxValue.y/2 && bb_array[currentMesh].poly_bb[i].MinValue.y/2 == passedBuffer->MinValue.y/2) && (bb_array[currentMesh].poly_bb[i].MaxValue.z/2 == passedBuffer->MaxValue.z/2 && bb_array[currentMesh].poly_bb[i].MinValue.z/2 == passedBuffer->MinValue.z/2))
        {
            bb_array[currentMesh].poly_bb[i].MinValue.x = passedBuffer->MinValue.x;
            merged ++;
        }
        else if (bb_array[currentMesh].poly_bb[i].MaxValue.y/2 == passedBuffer->MinValue.y/2 && (bb_array[currentMesh].poly_bb[i].MinValue.x/2 == passedBuffer->MinValue.x/2 && bb_array[currentMesh].poly_bb[i].MaxValue.x/2 == passedBuffer->MaxValue.x/2) && (bb_array[currentMesh].poly_bb[i].MaxValue.z/2 == passedBuffer->MaxValue.z/2 && bb_array[currentMesh].poly_bb[i].MinValue.z/2 == passedBuffer->MinValue.z/2))
        {
            bb_array[currentMesh].poly_bb[i].MaxValue.y = passedBuffer->MaxValue.y;
            merged ++;
        }
        else if (bb_array[currentMesh].poly_bb[i].MinValue.y/2 == passedBuffer->MaxValue.y/2 && (bb_array[currentMesh].poly_bb[i].MinValue.x/2 == passedBuffer->MinValue.x/2 && bb_array[currentMesh].poly_bb[i].MaxValue.x/2 == passedBuffer->MaxValue.x/2) && (bb_array[currentMesh].poly_bb[i].MaxValue.z/2 == passedBuffer->MaxValue.z/2 && bb_array[currentMesh].poly_bb[i].MinValue.z/2 == passedBuffer->MinValue.z/2))
        {
            bb_array[currentMesh].poly_bb[i].MinValue.y = passedBuffer->MinValue.y;
            merged ++;
        }
        else if ((bb_array[currentMesh].poly_bb[i].MaxValue.z/2 == passedBuffer->MinValue.z/2) && (bb_array[currentMesh].poly_bb[i].MinValue.x/2 == passedBuffer->MinValue.x/2 && bb_array[currentMesh].poly_bb[i].MaxValue.x/2 == passedBuffer->MaxValue.x/2) && (bb_array[currentMesh].poly_bb[i].MaxValue.y/2 == passedBuffer->MaxValue.y/2 && bb_array[currentMesh].poly_bb[i].MinValue.y/2 == passedBuffer->MinValue.y/2))
        {
            bb_array[currentMesh].poly_bb[i].MaxValue.z = passedBuffer->MaxValue.z;
            merged ++;
        }
        else if ((bb_array[currentMesh].poly_bb[i].MinValue.z/2 == passedBuffer->MaxValue.z/2) && (bb_array[currentMesh].poly_bb[i].MinValue.x/2 == passedBuffer->MinValue.x/2 && bb_array[currentMesh].poly_bb[i].MaxValue.x/2 == passedBuffer->MaxValue.x/2) && (bb_array[currentMesh].poly_bb[i].MaxValue.y/2 == passedBuffer->MaxValue.y/2 && bb_array[currentMesh].poly_bb[i].MinValue.y/2 == passedBuffer->MinValue.y/2))
        {
            bb_array[currentMesh].poly_bb[i].MinValue.z = passedBuffer->MinValue.z;
            merged ++;
        }
    }
       return merged;
}



int delete_duplicate_bb(void)
{
    for (unsigned int mesh=0; mesh<total_mesh; mesh++)
    {
        for (int i = 0; i < bb_array[mesh].total_bb; i++)
        {
            for (int ii = 0; ii < bb_array[mesh].total_bb; ii++)
            {
                if (bb_array[mesh].poly_bb[i].MaxValue.x == bb_array[mesh].poly_bb[ii].MaxValue.x && bb_array[mesh].poly_bb[i].MinValue.x == bb_array[mesh].poly_bb[ii].MinValue.x && bb_array[mesh].poly_bb[i].MaxValue.y == bb_array[mesh].poly_bb[ii].MaxValue.y && bb_array[mesh].poly_bb[i].MinValue.y == bb_array[mesh].poly_bb[ii].MinValue.y && bb_array[mesh].poly_bb[i].MaxValue.z == bb_array[mesh].poly_bb[ii].MaxValue.z && bb_array[mesh].poly_bb[i].MinValue.z == bb_array[mesh].poly_bb[ii].MinValue.z && (i != ii) && bb_array[mesh].poly_bb[ii].Rotation.x ==0 && bb_array[mesh].poly_bb[ii].Rotation.z == 0)
                    {
                        for (int j=ii; j<bb_array[mesh].total_bb-1; j++)
                            {
                                bb_array[mesh].poly_bb[j].MaxValue.x = bb_array[mesh].poly_bb[j+1].MaxValue.x; bb_array[mesh].poly_bb[j].MaxValue.y = bb_array[mesh].poly_bb[j+1].MaxValue.y; bb_array[mesh].poly_bb[j].MaxValue.z = bb_array[mesh].poly_bb[j+1].MaxValue.z;
                                bb_array[mesh].poly_bb[j].MinValue.x = bb_array[mesh].poly_bb[j+1].MinValue.x; bb_array[mesh].poly_bb[j].MinValue.y = bb_array[mesh].poly_bb[j+1].MinValue.y; bb_array[mesh].poly_bb[j].MinValue.z = bb_array[mesh].poly_bb[j+1].MinValue.z;
                            }
                                bb_array[mesh].total_bb -= 1;
                    }
                }
            }
    }
    return 1;
}


/****************************************
Generate collision BB based on polygons. Generates slopes as well depending on the angle, but
doesn't generate the heigth masks yet (right now it only outputs -1 (no mask), 0 and 1 (different masks, depending on the direction).
TODO : Proper BSP (I had to remove it because some BB got cut in two, which made you "fall" ingame.
TODO : Generate collision height masks.
TODO : Better merging of the BB, while also avoiding losing the slopes' data.
*****************************************/
void poly_2_BB(string filename)
{
    initialize_bb_array();
    string fileOutName = filename + ".txt";
    //string fileOutName = filename + ".ZTC";  //Z-Treme map COLLISION custom binary file format
    cout << "\nPOLYGON TO BOUNDING BOX - BETA\n";
    ofstream file(fileOutName, ios::out);
    int depthValue = 20; //Edit this to give more or less "depth" to the polygons (the program reads the normals and adds depth to the polygons)

    //fill_list_vertices();
    if (file.is_open())
    {
        for (unsigned int mesh = 0; mesh < total_mesh; mesh++)
        {
            //list_polygons_total_poly = 0;
            //file << "\nMesh no." << mesh << "\n"; -> If you use the Meshes for your BSP. I removed it because of a bug that cut BB in two and lost data.
            for (unsigned int i=0; i<mesh_array[mesh].data.nbPolygon; i++)
            {
               // int minX = 2147483647;                int minY = 2147483647;                int minZ = 2147483647;                int maxX = -2147483647;                int maxY = -2147483647;                int maxZ = -2147483647;
                _BB_Hitbox buffer;
                buffer.MinValue.x = mesh_array[mesh].data.pntbl[mesh_array[mesh].data.pltbl[i].Vertices[0]][0];
                buffer.MinValue.y = mesh_array[mesh].data.pntbl[mesh_array[mesh].data.pltbl[i].Vertices[0]][1];
                buffer.MinValue.z = mesh_array[mesh].data.pntbl[mesh_array[mesh].data.pltbl[i].Vertices[0]][2];
                buffer.MaxValue.x = mesh_array[mesh].data.pntbl[mesh_array[mesh].data.pltbl[i].Vertices[0]][0];
                buffer.MaxValue.y = mesh_array[mesh].data.pntbl[mesh_array[mesh].data.pltbl[i].Vertices[0]][1];
                buffer.MaxValue.z = mesh_array[mesh].data.pntbl[mesh_array[mesh].data.pltbl[i].Vertices[0]][2];

                for (int ii=0; ii<4; ii++)
                {
                   // cout << "\n*************************\n" << mesh_array[mesh].data.pltbl[i].Vertices[ii];
                    if (mesh_array[mesh].data.pntbl[mesh_array[mesh].data.pltbl[i].Vertices[ii]][0] < buffer.MinValue.x)
                        buffer.MinValue.x = mesh_array[mesh].data.pntbl[mesh_array[mesh].data.pltbl[i].Vertices[ii]][0];
                    if (mesh_array[mesh].data.pntbl[mesh_array[mesh].data.pltbl[i].Vertices[ii]][0] > buffer.MaxValue.x)
                        buffer.MaxValue.x = mesh_array[mesh].data.pntbl[mesh_array[mesh].data.pltbl[i].Vertices[ii]][0];
                    if (mesh_array[mesh].data.pntbl[mesh_array[mesh].data.pltbl[i].Vertices[ii]][1] < buffer.MinValue.y)
                        buffer.MinValue.y = mesh_array[mesh].data.pntbl[mesh_array[mesh].data.pltbl[i].Vertices[ii]][1];
                    if (mesh_array[mesh].data.pntbl[mesh_array[mesh].data.pltbl[i].Vertices[ii]][1] > buffer.MaxValue.y)
                        buffer.MaxValue.y = mesh_array[mesh].data.pntbl[mesh_array[mesh].data.pltbl[i].Vertices[ii]][1];
                    if (mesh_array[mesh].data.pntbl[mesh_array[mesh].data.pltbl[i].Vertices[ii]][2] < buffer.MinValue.z)
                        buffer.MinValue.z = mesh_array[mesh].data.pntbl[mesh_array[mesh].data.pltbl[i].Vertices[ii]][2];
                    if (mesh_array[mesh].data.pntbl[mesh_array[mesh].data.pltbl[i].Vertices[ii]][2] > buffer.MaxValue.z)
                        buffer.MaxValue.z = mesh_array[mesh].data.pntbl[mesh_array[mesh].data.pltbl[i].Vertices[ii]][2];
                }

                if (buffer.MinValue.x > 0) {buffer.MinValue.x = (buffer.MinValue.x + 32768)/65536;}
                else  {buffer.MinValue.x = (buffer.MinValue.x - 32768)/65536;}
                if (buffer.MinValue.y > 0) {buffer.MinValue.y = (buffer.MinValue.y + 32768)/65536;}
                else  {buffer.MinValue.y = (buffer.MinValue.y - 32768)/65536;}
                if (buffer.MinValue.z > 0) {buffer.MinValue.z = (buffer.MinValue.z + 32768)/65536;}
                else  {buffer.MinValue.z = (buffer.MinValue.z - 32768)/65536;}
                if (buffer.MaxValue.x > 0) {buffer.MaxValue.x = (buffer.MaxValue.x + 32768)/65536;}
                else  {buffer.MaxValue.x = (buffer.MaxValue.x - 32768)/65536;}
                if (buffer.MaxValue.y > 0) {buffer.MaxValue.y = (buffer.MaxValue.y + 32768)/65536;}
                else  {buffer.MaxValue.y = (buffer.MaxValue.y - 32768)/65536;}
                if (buffer.MaxValue.z > 0) {buffer.MaxValue.z = (buffer.MaxValue.z + 32768)/65536;}
                else  {buffer.MaxValue.z = (buffer.MaxValue.z - 32768)/65536;}

                if (buffer.MaxValue.x - buffer.MinValue.x == 0)
                    {
                       if (mesh_array[mesh].data.pltbl[i].norm[0] > 0) {buffer.MinValue.x -= depthValue;}
                       else if (mesh_array[mesh].data.pltbl[i].norm[0] < 0) {buffer.MaxValue.x += depthValue;}
                    }
                if (buffer.MaxValue.y - buffer.MinValue.y == 0)
                    {
                        if (mesh_array[mesh].data.pltbl[i].norm[1] > 0) buffer.MinValue.y -= depthValue;
                        else if (mesh_array[mesh].data.pltbl[i].norm[1] < 0) buffer.MaxValue.y += depthValue;
                    }
                if (buffer.MaxValue.z - buffer.MinValue.z == 0)
                    {
                        if (mesh_array[mesh].data.pltbl[i].norm[2] > 0) buffer.MinValue.z -= depthValue;
                        else if (mesh_array[mesh].data.pltbl[i].norm[2] < 0) buffer.MaxValue.z += depthValue;
                    }

                if (mesh_array[mesh].data.pltbl[i].norm[0]!=0 && mesh_array[mesh].data.pltbl[i].norm[1]!=0)  //Slope along the Z axis, we need to calculate it's value.
                {
                    buffer.Rotation.x = 0;
                    //int hypotenuse = jo_sqrt(((buffer.MaxValue.x-buffer.MinValue.x)^2) + ((buffer.MaxValue.y - buffer.MinValue.y)^2));
                    float slopeAngle = atan2(buffer.MaxValue.y-buffer.MinValue.y,buffer.MaxValue.x-buffer.MinValue.x)*(180/PI);
                    /*if ((buffer.MaxValue.x-buffer.MinValue.x)==(buffer.MaxValue.y-buffer.MinValue.y))
                        slopeAngle=45;
                    else {*/
                    //slopeAngle = atan2(buffer.MaxValue.y-buffer.MinValue.y,buffer.MaxValue.x-buffer.MinValue.x)*(180/PI);
                    //slopeAngle = slopeAngle * (180/PI);     //}
                    int slopeAngle_Int = (slopeAngle)+0.5;

                    if (slopeAngle_Int < 5 && slopeAngle_Int > -5) //Avoid wasting memory with negligible slopes due to mistakes made with 3D tools
                    {
                        buffer.Rotation.z = 0;
                        buffer.MaskID = -1;
                    }
                    else if (mesh_array[mesh].data.pltbl[i].norm[0]< 0)
                    {
                        buffer.Rotation.z = -slopeAngle_Int; // (need more tests, put negative or positive value here)
                        //buffer.MaskID = 1;
                        buffer.MaskID = CreateMask(buffer);
                    }
                    else
                    {
                        buffer.Rotation.z = slopeAngle_Int;
                        //buffer.MaskID = 0;
                        buffer.MaskID = CreateMask(buffer);
                    }//buffer.MaskID = total_Masks;
                }
                else if (mesh_array[mesh].data.pltbl[i].norm[2]!=0 && mesh_array[mesh].data.pltbl[i].norm[1]!=0) //Slope along the X axis
                {
                    buffer.Rotation.z = 0;
                    float slopeAngle = atan2(buffer.MaxValue.y-buffer.MinValue.y,buffer.MaxValue.z-buffer.MinValue.z) * (180/PI);
                    /*if ((buffer.MaxValue.z-buffer.MinValue.z)==(buffer.MaxValue.y-buffer.MinValue.y))
                        slopeAngle=45;
                    else
                    {   slopeAngle = atan2(buffer.MaxValue.y-buffer.MinValue.y,buffer.MaxValue.z-buffer.MinValue.z);
                        slopeAngle = slopeAngle * (180/PI); }*/
                    int slopeAngle_Int = slopeAngle+0.5;
                    /*if (slopeAngle < 0.0f) slopeAngle_Int = (slopeAngle)-0.5;
                    else slopeAngle_Int = (slopeAngle)+0.5;
                    cout << "\nSLOPE ANGLE = " << slopeAngle_Int << "\n";*/
                    if (slopeAngle_Int < 5 && slopeAngle_Int > -5) //Disregard low slopes as they might just be mistakes made with the 3D editor
                    {
                        buffer.Rotation.x = 0;
                        buffer.MaskID = -1;
                    }
                    else if (mesh_array[mesh].data.pltbl[i].norm[2]> 0)
                    {
                        buffer.Rotation.x = slopeAngle_Int;
                        //buffer.MaskID = 1;
                        buffer.MaskID = CreateMask(buffer);
                    }
                    else
                    {
                        buffer.Rotation.x = -slopeAngle_Int;
                        //buffer.MaskID = 0;
                        buffer.MaskID = CreateMask(buffer);
                    }
                    //buffer.Rotation.x = slopeAngle_Int;
                    //buffer.MaskID = total_Masks;
                }
                else
                {
                    buffer.Rotation.x = 0;
                    buffer.Rotation.z = 0;
                    buffer.MaskID=-1;
                }

                   if (refine_poly_2_bb_list(&buffer, mesh) > 0)
                   {
                        //cout << "Refining results. Merging bounding boxes...\n";
                   }
                   else
                   {
                    bb_array[mesh].poly_bb[bb_array[mesh].total_bb].MaxValue.x = buffer.MaxValue.x; bb_array[mesh].poly_bb[bb_array[mesh].total_bb].MaxValue.y = buffer.MaxValue.y; bb_array[mesh].poly_bb[bb_array[mesh].total_bb].MaxValue.z = buffer.MaxValue.z;
                    bb_array[mesh].poly_bb[bb_array[mesh].total_bb].MinValue.x = buffer.MinValue.x; bb_array[mesh].poly_bb[bb_array[mesh].total_bb].MinValue.y = buffer.MinValue.y; bb_array[mesh].poly_bb[bb_array[mesh].total_bb].MinValue.z = buffer.MinValue.z;
                    bb_array[mesh].poly_bb[bb_array[mesh].total_bb].Rotation.x = buffer.Rotation.x; bb_array[mesh].poly_bb[bb_array[mesh].total_bb].Rotation.z = buffer.Rotation.z;
                    bb_array[mesh].poly_bb[bb_array[mesh].total_bb].MaskID=buffer.MaskID;
                    bb_array[mesh].total_bb ++;
                   }

                //cout << "\nVert : " << mesh_array[mesh].data.pntbl[mesh_array[mesh].data.pltbl[i].Vertices[1]][0];
            }

            delete_duplicate_bb();
        }

        /*for (int mesh=0; mesh<total_mesh; mesh++)
        {
            for (int i=0; i<bb_array[mesh].total_bb; i++)
            {
                refine_poly_2_bb_list(&bb_array[mesh].poly_bb[i], mesh);
            }
        }*/

        int total_bb=0;
        for (unsigned int mesh=0; mesh<total_mesh; mesh++)
        {
            total_bb += bb_array[mesh].total_bb;
        }

        file << "#ifndef __ZONE_BB_H__\n#define __ZONE_BB_H__\n\n";
        file << "#define total_BB (" << total_bb << ")\n\n";
        file << "typedef struct _grids\n{\nint PointX;\nint LengthX;\nint PointY;\nint LengthY;\nint PointZ;\nint LengthZ;\nchar Mask;\nshort SlopeRXAngle;\nshort SlopeRZAngle;\n} grids;\n\n";
        file << "const grids const zone_bb[]=\n{\n";
        for (unsigned int mesh=0; mesh<total_mesh; mesh++)
            {
                file << "\n//Mesh no." << mesh << "\n";
                for (int i = 0; i < bb_array[mesh].total_bb ; i++)
                {
                    file << "{" << (bb_array[mesh].poly_bb[i].MinValue.x) << ", " << ((bb_array[mesh].poly_bb[i].MaxValue.x-bb_array[mesh].poly_bb[i].MinValue.x)) << ", " << (bb_array[mesh].poly_bb[i].MinValue.y) << ", " << ((bb_array[mesh].poly_bb[i].MaxValue.y-bb_array[mesh].poly_bb[i].MinValue.y)) << ", " << (bb_array[mesh].poly_bb[i].MinValue.z) << ", " << ((bb_array[mesh].poly_bb[i].MaxValue.z-bb_array[mesh].poly_bb[i].MinValue.z)) << ", ";
                   // file << "{" << (poly_bb[i].MinValue.x>>16) << ", " << ((poly_bb[i].MaxValue.x-poly_bb[i].MinValue.x)>>16) << ", " << (poly_bb[i].MinValue.y>>16) << ", " << ((poly_bb[i].MaxValue.y-poly_bb[i].MinValue.y)>>16) << ", " << (poly_bb[i].MinValue.z>>16) << ", " << ((poly_bb[i].MaxValue.z-poly_bb[i].MinValue.z)>>16) << ", ";
                    file << bb_array[mesh].poly_bb[i].MaskID  <<", " << bb_array[mesh].poly_bb[i].Rotation.x << ", " << bb_array[mesh].poly_bb[i].Rotation.z << "},\n";
                }
            }
        file << "};";
        file << "\n\n//************************************************\n//TOTAL VALUES :  " << total_bb << "\n";

        file << "unsigned int zoneBSP[" << total_mesh << "] [2] = \n{\n";

        int idx=0;
        for (unsigned int mesh=0; mesh<total_mesh; mesh++)
        {
            file << "{" << idx << ", " << bb_array[mesh].total_bb + idx << "},\n";
            idx += bb_array[mesh].total_bb;
        }
        file << "};\n\n";

        /*
        unsigned int zone1_BSP[5][2]=
{
    {0, 22},
    {22, 56},
    {56, 87},
    {87, 129},
    {129, 188},
};

        */

        /*
        for (int refine = 0; refine < list_polygons_total_poly; refine++)
        {
                if (refine_poly_2_bb_list(&poly_bb[refine]) > 0)
                {
                      //  poly_bb[refine].MaxValue.x = poly_bb[refine+1].MaxValue.x; poly_bb[refine].MaxValue.y = poly_bb[refine+1].MaxValue.y; poly_bb[refine].MaxValue.z = poly_bb[refine+1].MaxValue.z;
                      //  poly_bb[refine].MinValue.x = poly_bb[refine+1].MinValue.x; poly_bb[refine].MinValue.y = poly_bb[refine+1].MinValue.y; poly_bb[refine].MinValue.z = poly_bb[refine+1].MinValue.z;
                }
        }*/
    file << "\nint Mask[]= {\n{\n";
    for (int i=0; i < Total_Mask; i++)
    {
        file << "{";
        for (int ii=0; ii < 100; ii++)
        {
            file << MaskArray[i][ii] << ", ";
        }
        file << "},\n";
    }
    file << "\n";

    file << "#endif";
    file.close();
    }
}



/******************************
This function prevents having false data, like if all your points are > 0, then your minimum value would still be 0.
By putting everything to their opposite value, we make sure that the min/max values are correct
******************************/
void initialize_BB_hitbox(void)
{
    for (unsigned int i = 0; i < total_mesh; i++)
    {
        BSP_BB[i].MinValue.x = 2147483647;
        BSP_BB[i].MinValue.y = 2147483647;
        BSP_BB[i].MinValue.z = 2147483647;
        BSP_BB[i].MaxValue.x = -2147483647;
        BSP_BB[i].MaxValue.y = -2147483647;
        BSP_BB[i].MaxValue.z = -2147483647;
    }
}

/*
void initialize_global_bb_hitbox(void)
{
    for (int i = 0; i < 20; i++)
    {
        for (int ii = 0; ii < 3000; ii++)
        {
            GLOBAL_Hitbox[i].BB_Hitbox[ii].MinValue.x = {2147483647};
            GLOBAL_Hitbox[i].BB_Hitbox[ii].MinValue.y = {2147483647};
            GLOBAL_Hitbox[i].BB_Hitbox[ii].MinValue.z = {2147483647};
            GLOBAL_Hitbox[i].BB_Hitbox[ii].MaxValue.x = {-2147483647};
            GLOBAL_Hitbox[i].BB_Hitbox[ii].MaxValue.y = {-2147483647};
            GLOBAL_Hitbox[i].BB_Hitbox[ii].MaxValue.z = {-2147483647};
        }
        GLOBAL_Hitbox[i].LengthBBValues = 0;
        GLOBAL_Hitbox[i].BB_Boundaries.MinValue.x = {2147483647};
        GLOBAL_Hitbox[i].BB_Boundaries.MinValue.y = {2147483647};
        GLOBAL_Hitbox[i].BB_Boundaries.MinValue.z = {2147483647};
        GLOBAL_Hitbox[i].BB_Boundaries.MaxValue.x = {-2147483647};
        GLOBAL_Hitbox[i].BB_Boundaries.MaxValue.y = {-2147483647};
        GLOBAL_Hitbox[i].BB_Boundaries.MaxValue.z = {-2147483647};

    }
}*/

/******************************************************************
The BSP Hitbox is used for when we draw the data. That means that whatever assets you have in your .h file, they should be close to each other because
you will use the BSP hitbox to display them or not depending on their distance from your avatar/camera in order to reduce CPU load since it won't need
to do matrix translations/rotations/scaling
******************************************************************/
/*void generate_BSP_hitbox(void)
{

    initialize_BSP_hitbox();
    if (is_BB_mesh == true) return;  //Since we include all the Bounding boxes from the level, which is low (usually less than 200), we don't really need binary space partitioning (for sake of simplicity, it's disabled)
    for (int meshID = 0; meshID < total_mesh; meshID++)
    {
        for (int i = 0; i < mesh_array[meshID].data.nbPoint; i++)
        {
          if (mesh_array[meshID].data.pntbl[i][0] < BSP_Hitbox.MinValue.x) BSP_Hitbox.MinValue.x = mesh_array[meshID].data.pntbl[i][0];
          if (mesh_array[meshID].data.pntbl[i][0] > BSP_Hitbox.MaxValue.x) BSP_Hitbox.MaxValue.x = mesh_array[meshID].data.pntbl[i][0];
          if (mesh_array[meshID].data.pntbl[i][1] < BSP_Hitbox.MinValue.y) BSP_Hitbox.MinValue.y = mesh_array[meshID].data.pntbl[i][1];
          if (mesh_array[meshID].data.pntbl[i][1] > BSP_Hitbox.MaxValue.y) BSP_Hitbox.MaxValue.y = mesh_array[meshID].data.pntbl[i][1];
          if (mesh_array[meshID].data.pntbl[i][2] < BSP_Hitbox.MinValue.z) BSP_Hitbox.MinValue.z = mesh_array[meshID].data.pntbl[i][2];
          if (mesh_array[meshID].data.pntbl[i][2] > BSP_Hitbox.MaxValue.z) BSP_Hitbox.MaxValue.z = mesh_array[meshID].data.pntbl[i][2];
        }
    }
}*/


/******************************************
The Bounding Box hitbox is for your avatar's collision detection. You should use axis-aligned bounding boxes with your 3D editor software (like Blender),
align them on the "real" polygons, convert everything to JO ENGINE compatible .h file. Keep it low (less than 200 should be enough in most scenarios).
These boxes in the .h file WON'T be used by Saturn : you only need them to compile a file with all the bounding boxes, which will be sent to the Saturn by putting it in your c code
(or importing it via .bin files). The slopes aren't calculated yet.
******************************************/
void generate_BB_hitbox(string filename)
{
    string name;
    name= filename+"GBB.txt";
    initialize_BB_hitbox();
    for (unsigned int meshID = 0; meshID < total_mesh; meshID++)
    {
        for (unsigned int i = 0; i < mesh_array[meshID].data.nbPoint; i++)
        {
          if (mesh_array[meshID].data.pntbl[i][0] < BSP_BB[meshID].MinValue.x) BSP_BB[meshID].MinValue.x = mesh_array[meshID].data.pntbl[i][0];
          if (mesh_array[meshID].data.pntbl[i][0] > BSP_BB[meshID].MaxValue.x) BSP_BB[meshID].MaxValue.x = mesh_array[meshID].data.pntbl[i][0];
          if (mesh_array[meshID].data.pntbl[i][1] < BSP_BB[meshID].MinValue.y) BSP_BB[meshID].MinValue.y = mesh_array[meshID].data.pntbl[i][1];
          if (mesh_array[meshID].data.pntbl[i][1] > BSP_BB[meshID].MaxValue.y) BSP_BB[meshID].MaxValue.y = mesh_array[meshID].data.pntbl[i][1];
          if (mesh_array[meshID].data.pntbl[i][2] < BSP_BB[meshID].MinValue.z) BSP_BB[meshID].MinValue.z = mesh_array[meshID].data.pntbl[i][2];
          if (mesh_array[meshID].data.pntbl[i][2] > BSP_BB[meshID].MaxValue.z) BSP_BB[meshID].MaxValue.z = mesh_array[meshID].data.pntbl[i][2];
        }
    }
    ofstream ofile(name.c_str(), ios::out | ios::ate);


    ofile << "#ifndef __ZONE1BB_H__ \n#define __ZONE1_BB_H\n";
    ofile << "#include ''../../level.h''\n\n";
    ofile << "#define zone_total_blocks (" << total_mesh << ")\n\n";


    for (unsigned int i = 0; i < total_mesh; i ++)
    {
        ofile << "\nconst grids const zone_gbb_Mesh" << i << "[] =\n{\n";
        //Here we round up to Int value (since it doesn't keep decimals, we add/remove 0.5 to round up to the superior value)
        if (BSP_BB[i].MinValue.x < 0) BSP_BB[i].MinValue.x = (BSP_BB[i].MinValue.x -32768)/65536;
            else BSP_BB[i].MinValue.x = (BSP_BB[i].MinValue.x + 32768)/65536;
        if (BSP_BB[i].MinValue.y < 0) BSP_BB[i].MinValue.y = (BSP_BB[i].MinValue.y-32768)/65536;
            else BSP_BB[i].MinValue.y = (BSP_BB[i].MinValue.y + 32768)/65536;
        if (BSP_BB[i].MinValue.z < 0) BSP_BB[i].MinValue.z = (BSP_BB[i].MinValue.z-32768)/65536;
            else BSP_BB[i].MinValue.z = (BSP_BB[i].MinValue.z + 32768)/65536;
        if (BSP_BB[i].MaxValue.x < 0) BSP_BB[i].MaxValue.x = (BSP_BB[i].MaxValue.x - 32768)/65536;
            else BSP_BB[i].MaxValue.x = (BSP_BB[i].MaxValue.x + 32768)/65536;
        if (BSP_BB[i].MaxValue.y < 0) BSP_BB[i].MaxValue.y = (BSP_BB[i].MaxValue.y - 32768)/65536;
            else BSP_BB[i].MaxValue.y = (BSP_BB[i].MaxValue.y + 32768)/65536;
        if (BSP_BB[i].MaxValue.z < 0) BSP_BB[i].MaxValue.z = (BSP_BB[i].MaxValue.z - 32768)/65536;
            else BSP_BB[i].MaxValue.z = (BSP_BB[i].MaxValue.z + 32768)/65536;

        //ofile << "   {";
        ofile << BSP_BB[i].MinValue.x << ", " << (BSP_BB[i].MaxValue.x-BSP_BB[i].MinValue.x ) << ", ";
        ofile << BSP_BB[i].MinValue.y << ", " << (BSP_BB[i].MaxValue.y-BSP_BB[i].MinValue.y ) << ", ";
        ofile << BSP_BB[i].MinValue.z << ", " << (BSP_BB[i].MaxValue.z-BSP_BB[i].MinValue.z ) << ", ";
        ofile << "-1, 0, 0},\n";
    }
    ofile << "};\n#endif";
    ofile.close();
}
   /* name=filename+".bin";
    ofstream obinfile(name.c_str(), ios::out | ios::binary);

    if (obinfile.is_open())
    {
        for (int meshID = 0; meshID < total_mesh; meshID ++)
        {
            char minx[4] = {(BSP_BB[i].MinValue.x)};
            char miny[4] = {BSP_BB[i].MinValue.y};
            char minz[4] = {BSP_BB[i].MinValue.z};
            char lenx[4] = {BSP_BB[i].MaxValue.x - BSP_BB[i].MinValue.x};
            char leny[4] = {BSP_BB[i].MaxValue.y - BSP_BB[i].MinValue.y};
            char lenz[4] = {BSP_BB[i].MaxValue.z - BSP_BB[i].MinValue.z};

            obinfile.write (minx, 2);
            obinfile.write (lenx, 2);
            obinfile.write (miny, 2);
            obinfile.write(leny, 2);
            obinfile.write(minz, 2);
            obinfile.write(lenz, 2);
        }
    }

    obinfile.close();
}*/










#endif
